package rozdzial07c;

import javafx.animation.AnimationTimer;
import javafx.application.Application;
import javafx.embed.swing.SwingFXUtils;
import javafx.geometry.Rectangle2D;
import javafx.scene.Scene;
import javafx.scene.SnapshotParameters;
import javafx.scene.image.WritableImage;
import javafx.scene.layout.StackPane;
import javafx.scene.paint.Color;
import javafx.scene.shape.Circle;
import javafx.stage.Stage;

import javax.imageio.ImageIO;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import java.time.Instant;
/**
 * @author Jacek Piechota
 <p>Seryjne migawki (gif) z węzła {@code Node} w trakcie trwania animacji</p>
 <p>Po uruchomieniu klasy w pakiecie 'gifs' zobaczymy 60 plików 'gif' o nazwach od 'rys07_01.gif' do 'rys07_60.gif' . A oto jeden z tych obrazków 'rys07_30.gif':</p>
 <img src="gifs/rys07_30.gif" width="270", height="300">
  */
public class Listing07c_02 extends Application {
    private double radius = 30;
    private int counter;
    private StackPane root;
    private Circle circle;
    private SnapshotParameters params;

    @Override
    public void start(Stage stage) {
        root = new StackPane();
        //-
        counter = 1;
        params = new SnapshotParameters();
        params.setFill(Color.WHITE);
        params.setViewport(new
                Rectangle2D(0, 0, 270, 300));
        //-
        circle = new Circle(radius);
        circle.setFill(Color.DARKCYAN);
        root.getChildren().add(circle);
        AnimationTimer timer = new MyTimer();
        timer.start();
        Scene scene = new Scene(root, 300, 300);
        stage.setTitle("AnimationTimer");
        stage.setScene(scene);
        stage.show();
    }

    private class MyTimer extends AnimationTimer {
        @Override
        public void handle(long now) {
            WritableImage wi = root.snapshot(params, null);
            File file = new File(
                    "rozdzial07c/src/rozdzial07c/gifs/rys07_"
                    + leadingZeroes(2, counter) + ".gif");
            BufferedImage bi = SwingFXUtils.fromFXImage(wi,
                    null);
            try {
                ImageIO.write(bi, "gif", file);
                counter++;
                System.out.println(Instant.now());
            } catch (IOException e) {
                e.printStackTrace();
            }
            radius -= 0.5;
            circle.radiusProperty().set(radius);
            if (radius <= 0) {
                radius = 30.0;
                circle.radiusProperty().set(radius);
                stop();
                System.out.println("Animation stopped");
            }
        }
    }
    private static String leadingZeroes(int digits, int number) {
        return String.format("%0" + String.valueOf(digits) + "d", number);
    }
    public static void main(String[] args) {
        Application.launch(args);
    }
}